Index: anonymous.cs
===================================================================
--- anonymous.cs	(revision 63019)
+++ anonymous.cs	(working copy)
@@ -1029,124 +1636,264 @@
 			}
 		}
 
-		ScopeInfo GetScopeForBlock (Block block)
+		// The method scope
+		ScopeInfo method_scope;
+		bool computed_method_scope = false;
+		
+		//
+		// Track the scopes that this method has used.  At the
+		// end this is used to determine the ScopeInfo that will
+		// host the method
+		//
+		ArrayList scopes_used = new ArrayList ();
+		
+		public void RegisterScope (ScopeInfo scope)
 		{
+			if (scopes_used.Contains (scope))
+				return;
+			scopes_used.Add (scope);
+		}
+
+		// Returns the deepest of two scopes
+		ScopeInfo Deepest (ScopeInfo a, ScopeInfo b)
+		{
+			ScopeInfo p;
+
+			Report.Debug (64, "DEEPEST", this, a, a.ParentScope, b, b.ParentScope);
+
+			if (a == null)
+				return b;
+			if (b == null)
+				return a;
+			if (a == b)
+				return a;
+
+			//
+			// If they Scopes are on the same CaptureContext, we do the double
+			// checks just so if there is an invariant change in the future,
+			// we get the exception at the end
+			//
+			for (p = a; p != null; p = p.ParentScope)
+				if (p == b)
+					return a;
+			
+			for (p = b; p != null; p = p.ParentScope)
+				if (p == a)
+					return b;
+
+			CaptureContext ca = a.CaptureContext;
+			CaptureContext cb = b.CaptureContext;
+
+			for (CaptureContext c = ca; c != null; c = c.ParentCaptureContext)
+				if (c == cb)
+					return a;
+
+			for (CaptureContext c = cb; c != null; c = c.ParentCaptureContext)
+				if (c == ca)
+					return b;
+			throw new Exception ("Should never be reached");
+		}
+
+		//
+		// Determines the proper host for a method considering the
+		// scopes it references
+		//
+		public void ComputeMethodHost ()
+		{
+			Report.Debug (64, "COMPUTE METHOD HOST", this, computed_method_scope,
+				      method_scope, scopes_used);
+
+			if (computed_method_scope)
+				return;
+
+			LinkScopes ();
+			
+			method_scope = null;
+			int top = scopes_used.Count;
+			computed_method_scope = true;
+
+			if (top == 0)
+				return;
+			
+			method_scope = (ScopeInfo) scopes_used [0];
+			if (top == 1)
+				return;
+
+			Report.Debug (64, "COMPUTE METHOD HOST #1", this, method_scope,
+				      scopes_used);
+			
+			for (int i = 1; i < top; i++)
+				method_scope = Deepest (method_scope, (ScopeInfo) scopes_used [i]);
+		}
+
+		public ScopeInfo Scope {
+			get {
+				if (computed_method_scope)
+					return method_scope;
+
+				//
+				// This means that ComputeMethodHost is not being called, most
+				// likely by someone who overwrote the CreateMethodHost method
+				//
+				throw new InternalErrorException (
+					"AnonymousContainer.Scope is being used before its " +
+					"container is computed");
+			}
+		}
+
+		internal AnonymousMethodHost CreateRootScope (TypeContainer parent, GenericMethod generic)
+		{
+			Report.Debug (64, "CREATE ROOT SCOPE", this, parent.Name, ToplevelOwner,
+				      ToplevelOwner.ScopeInfo);
+
+			AnonymousMethodHost root_scope = new AnonymousMethodHost (
+				this, ToplevelOwner, parent, generic);
+			AddRootScope (root_scope);
+			return root_scope;
+		}
+
+		internal void AddRootScope (ScopeInfo root_scope)
+		{
+			if (ToplevelOwner.ScopeInfo != null)
+				throw new InternalErrorException ();
+
+			ToplevelOwner.ScopeInfo = root_scope;
+			scopes.Add (ToplevelOwner.ID, root_scope);
+			RegisterScope (root_scope);
+		}
+
+		internal ScopeInfo GetScopeForBlock (Block block)
+		{
+			while (block.Implicit)
+				block = block.Parent;
+
 			ScopeInfo si = (ScopeInfo) scopes [block.ID];
+			Report.Debug (64, "GET SCOPE FOR BLOCK", this, block,
+				      block.ScopeInfo, block.Parent, si);
 			if (si != null)
 				return si;
-			si = new ScopeInfo (this, block);
+
+			block.ScopeInfo = si = new ScopeInfo (this, block);
 			scopes [block.ID] = si;
 			return si;
 		}
-		
-		public void AddLocal (AnonymousContainer am, LocalInfo li)
+
+		public Variable AddLocal (LocalInfo li)
 		{
-			if (li.Block.Toplevel != toplevel_owner){
-				ParentCaptureContext.AddLocal (am, li);
-				return;
-			}
+			Report.Debug (64, "ADD LOCAL", this, li.Name, loc, li.Block,
+				      li.Block.Toplevel, ToplevelOwner);
+
+			if (li.Block.Toplevel != ToplevelOwner)
+				return ParentCaptureContext.AddLocal (li);
+
 			ScopeInfo scope = GetScopeForBlock (li.Block);
 
 			//
 			// Adjust the owner
 			//
-			if (Host != null)
-				Host.RegisterScope (scope);
+			RegisterScope (scope);
 
+#if FIXME
 			//
 			// Adjust the user
 			//
 			am.RegisterScope (scope);
-			
-			if (captured_variables [li] != null)
-				return;
-			
+#endif
+
+			Variable var = (Variable) captured_variables [li];
+			Report.Debug (64, "ADD LOCAL #1", this, li.Name, scope, var);
+			if (var == null) {
+				var = scope.AddLocal (li);
+				captured_variables.Add (li, var);
+			}
+
 			have_captured_vars = true;
-			captured_variables [li] = li;
-			scope.AddLocal (li);
+			return var;
 		}
 
 		//
-		// Retursn the CaptureContext for the block that defines the parameter `name'
+		// Returns the CaptureContext for the block that defines the parameter `name'
 		//
-		static CaptureContext _ContextForParameter (ToplevelBlock current, string name)
+		static CaptureContext _ContextForParameter (ToplevelBlock current, Parameter par)
 		{
 			ToplevelBlock container = current.Container;
 			if (container != null){
-				CaptureContext cc = _ContextForParameter (container, name);
+				CaptureContext cc = _ContextForParameter (container, par);
 				if (cc != null)
 					return cc;
 			}
-			if (current.IsParameterReference (name))
+			if (current.IsParameterReference (par.Name))
 				return current.ToplevelBlockCaptureContext;
 			return null;
 		}
 
-		static CaptureContext ContextForParameter (ToplevelBlock current, string name)
+		static CaptureContext ContextForParameter (ToplevelBlock current, Parameter par)
 		{
-			CaptureContext cc = _ContextForParameter (current, name);
+			CaptureContext cc = _ContextForParameter (current, par);
 			if (cc == null)
-				throw new Exception (String.Format ("request for parameteter {0} failed: not found", name));
+				throw new InternalErrorException (
+					"Request for parameteter {0} failed: not found", par.Name);
 			return cc;
 		}
-		
+
 		//
 		// Records the captured parameter at the appropriate CaptureContext
 		//
-		public void AddParameter (EmitContext ec, AnonymousContainer am,
-					  string name, Type t, int idx)
+		public Variable AddParameter (EmitContext ec, Parameter par, int idx)
 		{
-			CaptureContext cc = ContextForParameter (ec.CurrentBlock.Toplevel, name);
-
-			cc.AddParameterToContext (am, name, t, idx);
+			CaptureContext cc = ContextForParameter (ec.CurrentBlock.Toplevel, par);
+			return cc.AddParameterToContext (par, idx);
 		}
 
 		//
 		// Records the parameters in the context
 		//
-		public void AddParameterToContext (AnonymousContainer am, string name, Type t, int idx)
+		public Variable AddParameterToContext (Parameter par, int idx)
 		{
 			if (captured_parameters == null)
 				captured_parameters = new Hashtable ();
-			if (captured_parameters [name] == null)
-				captured_parameters [name] = new CapturedParameter (t, idx);
 
-			ScopeInfo scope = GetScopeForBlock (toplevel_owner);
-			scope.HostsParameters = true;
-			am.RegisterScope (scope);
+			AnonymousMethodHost host = ToplevelOwner.AnonymousMethodHost;
+			host.HostsParameters = true;
+
+			Variable var = (Variable) captured_parameters [par];
+			if (var == null) {
+				var = host.AddParameter (par, idx);
+				captured_parameters.Add (par, var);
+			}
+
+			return var;
 		}
 
 		//
 		// Captured fields are only recorded on the topmost CaptureContext, because that
 		// one is the one linked to the owner of instance fields
 		//
-		public void AddField (EmitContext ec, AnonymousContainer am, FieldExpr fe)
+		public void AddField (EmitContext ec, FieldExpr fe)
 		{
 			if (fe.FieldInfo.IsStatic)
-				throw new Exception ("Attempt to register a static field as a captured field");
+				throw new InternalErrorException (
+					"Attempt to register a static field as a captured field");
+
 			CaptureContext parent = ParentCaptureContext;
 			if (parent != null) {
-				parent.AddField (ec, am, fe);
+				parent.AddField (ec, fe);
 				return;
 			}
 
-			ScopeInfo scope = GetScopeForBlock (toplevel_owner);
-			am.RegisterScope (scope);
+			ScopeInfo scope = GetScopeForBlock (ToplevelOwner);
+			RegisterScope (scope);
 		}
 
-		public void CaptureThis (AnonymousContainer am)
+		public void CaptureThis ()
 		{
-			if (am == null)
-				throw new Exception ("Internal Compiler error: Capturethis called with a null method");
 			CaptureContext parent = ParentCaptureContext;
 			if (parent != null) {
-				parent.CaptureThis (am);
+				parent.CaptureThis ();
 				return;
 			}
-			referenced_this = true;
 
-			ScopeInfo scope = GetScopeForBlock (toplevel_owner);
-			am.RegisterScope (scope);
+			Host.RootScope.CaptureThis ();
 		}
 
 		public bool HaveCapturedVariables {
@@ -1164,21 +1911,23 @@
 			}
 		}
 
-		public bool IsCaptured (LocalInfo local)
+		public Variable GetCapturedVariable (LocalInfo local)
 		{
-			foreach (ScopeInfo si in scopes.Values){
-				if (si.IsCaptured (local))
-					return true;
-			}
-			return false;
+			return (Variable) captured_variables [local];
 		}
 
+		public Variable GetCapturedParameter (Parameter par)
+		{
+			return (Variable) captured_parameters [par];
+		}
+
 		//
 		// Returns whether the parameter is captured
 		//
 		public bool IsParameterCaptured (string name)
 		{
-			if (ParentCaptureContext != null && ParentCaptureContext.IsParameterCaptured (name))
+			if ((ParentCaptureContext != null) &&
+			    ParentCaptureContext.IsParameterCaptured (name))
 				return true;
 			
 			if (captured_parameters != null)
@@ -1186,88 +1935,58 @@
 			return false;
 		}
 
-		public void EmitAnonymousHelperClasses (EmitContext ec)
+		public ExpressionStatement GetScopeInitializerForBlock (EmitContext ec, Block b)
 		{
-			if (roots.Count != 0){
-				foreach (ScopeInfo root in roots){
-					//
-					// FIXME: We really should do this in a per-ScopeInfo
-					// basis, instead of having the NeedThis applied to
-					// all of the roots.
-					//
-					root.NeedThis = HaveCapturedFields || referenced_this;
-					
-					root.EmitScopeType (ec);
-				}
-			} 
-		}
-
-		public void CloseAnonymousHelperClasses ()
-		{
-			if (roots.Count != 0)
-				foreach (ScopeInfo root in roots)
-					root.CloseTypes ();
-		}
-
-		public void EmitInitScope (EmitContext ec)
-		{
-			EmitAnonymousHelperClasses (ec);
-			if (roots.Count != 0)
-				foreach (ScopeInfo root in roots)
-					root.EmitInitScope (ec);		}
-
-		//
-		// This is called externally when we start emitting code for a block
-		// if the block has a ScopeInfo associated, emit the init code
-		//
-		public void EmitScopeInitFromBlock (EmitContext ec, Block b)
-		{
+			Report.Debug (64, "GET SCOPE INIT FOR BLOCK", this, Host, b);
 			ScopeInfo si = (ScopeInfo) scopes [b.ID];
 			if (si == null)
-				return;
+				return null;
 
-			si.EmitInitScope (ec);
+			Report.Debug (64, "GET SCOPE INIT FOR BLOCK #1", this, Host, b, si);
+			return si.GetScopeInitializer (ec);
 		}
 		
 		//
 		// Emits the opcodes necessary to load the instance of the captured
 		// variable in `li'
 		//
-		public void EmitCapturedVariableInstance (EmitContext ec, LocalInfo li,
+		public void EmitCapturedVariableInstance (EmitContext ec, Block block,
 							  AnonymousContainer am)
 		{
 			ILGenerator ig = ec.ig;
 			ScopeInfo si;
 
-			if (li.Block.Toplevel == toplevel_owner){
-				si = (ScopeInfo) scopes [li.Block.ID];
-				si.EmitScopeInstance (ig);
+			Report.Debug (64, "EMIT CAPTURED VARIABLE INSTANCE", this,
+				      am, block.ID, block.Toplevel.ID, ToplevelOwner.ID,
+				      block, block.Toplevel, ToplevelOwner);
+
+			while (block.Implicit)
+				block = block.Parent;
+
+			if (block.Toplevel == ToplevelOwner){
+				si = (ScopeInfo) scopes [block.ID];
+				si.EmitScopeInstance (ec);
 				return;
 			}
 
-			si = am.Scope;
+			Report.Debug (64, "EMIT CAPTURED VARIABLE INSTANCE #1", this,
+				      am, block.Toplevel, ToplevelOwner, am.Scope);
+
+			AnonymousMethodHost host = am.RootScope;
 			ig.Emit (OpCodes.Ldarg_0);
-			if (si != null){
-				if (am.IsIterator && (si.ScopeBlock.Toplevel == li.Block.Toplevel)) {
-					return;
-				}
+			if (host != null) {
+				Report.Debug (64, "EMIT CAPTURED VARIABLE INSTANCE #2", this,
+					      host, host.ParentLink, host.ScopeBlock,
+					      block, block.Toplevel);
 
-				while (si.ScopeBlock.ID != li.Block.ID){
-					if (si.ParentLink != null)
-						ig.Emit (OpCodes.Ldfld, si.ParentLink);
-					si = si.ParentScope;
-					if (si == null) {
-						si = am.Scope;
-						Console.WriteLine ("Target: {0} {1}", li.Block.ID, li.Name);
-						while (si.ScopeBlock.ID != li.Block.ID){
-							Console.WriteLine ("Trying: {0}", si.ScopeBlock.ID);
-							si = si.ParentScope;
-						}
-
-						throw new Exception (
-							     String.Format ("Never found block {0} starting at {1} while looking up {2}",
-									    li.Block.ID, am.Scope.ScopeBlock.ID, li.Name));
-					}
+				while (host.ScopeBlock.ID != block.ID){
+					if (host.ParentLink != null)
+						ig.Emit (OpCodes.Ldfld, host.ParentLink.FieldBuilder);
+					host = host.ParentHost;
+					if (host == null)
+						throw new InternalErrorException (
+							"Never found block {0} starting at {1}",
+							block.ID, am.RootScope.ScopeBlock.ID);
 				}
 			}
 		}
@@ -1275,135 +1994,34 @@
 		//
 		// Internal routine that loads the instance to reach parameter `name'
 		//
-		void EmitParameterInstance (EmitContext ec, string name)
+		public void EmitParameterInstance (EmitContext ec, Parameter par)
 		{
-			CaptureContext cc = ContextForParameter (ec.CurrentBlock.Toplevel, name);
+			CaptureContext cc = ContextForParameter (ec.CurrentBlock.Toplevel, par);
 			if (cc != this){
-				cc.EmitParameterInstance (ec, name);
+				cc.EmitParameterInstance (ec, par);
 				return;
 			}
 
-			CapturedParameter par_info = (CapturedParameter) captured_parameters [name];
-			if (par_info != null){
-				// 
-				// FIXME: implementing this.
-				//
+			if (ec.CurrentBlock.Toplevel == ToplevelOwner) {
+				ScopeInfo si = (ScopeInfo) scopes [ToplevelOwner.ID];
+				si.EmitScopeInstance (ec);
+				return;
 			}
-			ILGenerator ig = ec.ig;
 
-			ScopeInfo si;
+			AnonymousMethodHost host = ec.CurrentAnonymousMethod.RootScope;
+			ec.ig.Emit (OpCodes.Ldarg_0);
 
-			if (ec.CurrentBlock.Toplevel == toplevel_owner) {
-				si = (ScopeInfo) scopes [toplevel_owner.ID];
-				si.EmitScopeInstance (ig);
-			} else {
-				si = ec.CurrentAnonymousMethod.Scope;
-				ig.Emit (OpCodes.Ldarg_0);
-			}
-
-			if (si != null){
-				while (si.ParentLink != null) {
-					ig.Emit (OpCodes.Ldfld, si.ParentLink);
-					si = si.ParentScope;
+			if (host != null) {
+				while (host.ParentLink != null) {
+					ec.ig.Emit (OpCodes.Ldfld, host.ParentLink.FieldBuilder);
+					host = host.ParentHost;
 				} 
 			}
 		}
 
-		//
-		// Emits the code necessary to load the parameter named `name' within
-		// an anonymous method.
-		//
-		public void EmitParameter (EmitContext ec, string name, bool leave_copy, bool prepared, ref LocalTemporary temp)
-		{
-			CaptureContext cc = ContextForParameter (ec.CurrentBlock.Toplevel, name);
-			if (cc != this){
-				cc.EmitParameter (ec, name, leave_copy, prepared, ref temp);
-				return;
-			}
-			if (!prepared)
-				EmitParameterInstance (ec, name);
-			CapturedParameter par_info = (CapturedParameter) captured_parameters [name];
-			if (par_info != null){
-				// 
-				// FIXME: implementing this.
-				//
-			}
-			ec.ig.Emit (OpCodes.Ldfld, par_info.FieldBuilder);
-
-			if (leave_copy){
-				ec.ig.Emit (OpCodes.Dup);
-				temp = new LocalTemporary (par_info.FieldBuilder.FieldType);
-				temp.Store (ec);
-			}
-		}
-
-		//
-		// Implements the assignment of `source' to the paramenter named `name' within
-		// an anonymous method.
-		//
-		public void EmitAssignParameter (EmitContext ec, string name, Expression source, bool leave_copy, bool prepare_for_load, ref LocalTemporary temp)
-		{
-			CaptureContext cc = ContextForParameter (ec.CurrentBlock.Toplevel, name);
-			if (cc != this){
-				cc.EmitAssignParameter (ec, name, source, leave_copy, prepare_for_load, ref temp);
-				return;
-			}
-			ILGenerator ig = ec.ig;
-			CapturedParameter par_info = (CapturedParameter) captured_parameters [name];
-
-			EmitParameterInstance (ec, name);
-			if (prepare_for_load)
-				ig.Emit (OpCodes.Dup);
-			source.Emit (ec);
-			if (leave_copy){
-				ig.Emit (OpCodes.Dup);
-				temp = new LocalTemporary (par_info.FieldBuilder.FieldType);
-				temp.Store (ec);
-			}
-			ig.Emit (OpCodes.Stfld, par_info.FieldBuilder);
-			if (temp != null)
-				temp.Emit (ec);
-		}
-
-		//
-		// Emits the address for the parameter named `name' within
-		// an anonymous method.
-		//
-		public void EmitAddressOfParameter (EmitContext ec, string name)
-		{
-			CaptureContext cc = ContextForParameter (ec.CurrentBlock.Toplevel, name);
-			if (cc != this){
-				cc.EmitAddressOfParameter (ec, name);
-				return;
-			}
-			EmitParameterInstance (ec, name);
-			CapturedParameter par_info = (CapturedParameter) captured_parameters [name];
-			ec.ig.Emit (OpCodes.Ldflda, par_info.FieldBuilder);
-		}
-
-		//
-		// The following methods are only invoked on the host for the
-		// anonymous method.
-		//
-		public void EmitMethodHostInstance (EmitContext target, AnonymousContainer am)
-		{
-			ILGenerator ig = target.ig;
-			ScopeInfo si = am.Scope;
-
-			AnonymousContainer container = am.ContainerAnonymousMethod;
-
-			if ((si == null) || ((container != null) && (si == container.Scope))) {
-				ig.Emit (OpCodes.Ldarg_0);
-				return;
-			}
-
-			si.EmitInitScope (target);
-			si.EmitScopeInstance (ig);
-		}
-
 		public void RegisterCaptureContext ()
 		{
-			toplevel_owner.RegisterCaptureContext (this);
+			ToplevelOwner.RegisterCaptureContext (this);
 		}
 
 		//
@@ -1412,7 +2030,10 @@
 		//
 		bool IsAncestor (ScopeInfo probe, ScopeInfo scope)
 		{
+			Report.Debug (64, "IS ANCESTOR", scope, scope.ScopeBlock,
+				      scope.ScopeBlock.Parent, probe, probe.ScopeBlock);
 			for (Block b = scope.ScopeBlock.Parent; b != null; b = b.Parent){
+				Report.Debug (64, "IS ANCESTOR #1", b, probe.ScopeBlock);
 				if (probe.ScopeBlock == b)
 					return true;
 			}
@@ -1474,7 +2095,7 @@
 			}
 			return parent;
 		}
-		
+
 		//
 		// Links all the scopes
 		//
@@ -1483,7 +2104,9 @@
 		{
 			if (linked)
 				return;
-			
+
+			Report.Debug (64, "LINK SCOPES", this, ParentCaptureContext);
+
 			linked = true;
 			if (ParentCaptureContext != null)
 				ParentCaptureContext.LinkScopes ();
@@ -1492,9 +2115,14 @@
 			ScopeInfo [] scope_list = new ScopeInfo [scope_count];
 			scopes.Values.CopyTo (scope_list, 0);
 
+			Report.Debug (64, "LINK SCOPES #1", this, scope_list);
+
 			for (int i = 0; i < scope_count; i++){
 				ScopeInfo parent = GetParentScope (scope_list [i], scope_list);
 
+				Report.Debug (64, "LINK SCOPES #2", this, scope_list, i,
+					      scope_list [i], parent);
+
 				if (parent == null){
 					roots.Add (scope_list [i]);
 					continue;
@@ -1504,17 +2132,28 @@
 				parent.AddChild (scope_list [i]);
 			}
 
+			Report.Debug (64, "LINK SCOPES #3", this, ParentCaptureContext, roots);
+
 			//
 			// Link the roots to their parent containers if any.
 			//
 			if (ParentCaptureContext != null && roots.Count != 0){
 				ScopeInfo one_root = (ScopeInfo) roots [0];
 				bool found = false;
-				
+
+				Report.Debug (64, "LINK SCOPES #4", this, one_root,
+					      ParentCaptureContext.roots);
+
 				foreach (ScopeInfo a_parent_root in ParentCaptureContext.roots){
+					Report.Debug (64, "LINK SCOPES #5", this, a_parent_root,
+						      one_root);
+
 					if (!IsAncestor (a_parent_root, one_root))
 						continue;
 
+					Report.Debug (64, "LINK SCOPES #6", this, a_parent_root,
+						      one_root, roots);
+
 					found = true;
 					
 					// Found, link all the roots to this root
@@ -1533,6 +2172,13 @@
 					throw new Exception ("Internal compiler error: Did not find the parent for the root in the chain");
 				}
 			}
+
+			foreach (ScopeInfo si in scope_list) {
+				if (!si.Define ())
+					throw new InternalErrorException ();
+				if (si.DefineType () == null)
+					throw new InternalErrorException ();
+			}
 		}
 	}
 }
Index: expression.cs
===================================================================
--- expression.cs	(revision 63019)
+++ expression.cs	(working copy)
@@ -3309,6 +3309,7 @@
 		bool is_readonly;
 		bool prepared;
 		LocalTemporary temp;
+		Variable variable;
 
 		public LocalVariableReference (Block block, string name, Location l)
 		{
@@ -3363,20 +3364,18 @@
 			if (!VerifyAssigned (ec))
 				return null;
 
-			if (ec.CurrentAnonymousMethod != null){
-				//
-				// If we are referencing a variable from the external block
-				// flag it for capturing
-				//
-				if ((local_info.Block.Toplevel != ec.CurrentBlock.Toplevel) ||
-				    ec.CurrentAnonymousMethod.IsIterator)
-				{
-					if (local_info.AddressTaken){
-						AnonymousMethod.Error_AddressOfCapturedVar (local_info.Name, loc);
-						return null;
-					}
-					ec.CaptureVariable (local_info);
+			//
+			// If we are referencing a variable from the external block
+			// flag it for capturing
+			//
+			if (ec.MustCaptureVariable (local_info)) {
+				if (local_info.AddressTaken){
+					AnonymousMethod.Error_AddressOfCapturedVar (local_info.Name, loc);
+					return null;
 				}
+
+				variable = ec.CaptureVariable (local_info);
+				type = variable.Type;
 			}
 
 			return this;
@@ -3439,90 +3438,56 @@
 			return Name == lvr.Name && Block == lvr.Block;
 		}
 
+		public Variable Variable {
+			get { return variable != null ? variable : local_info.Variable; }
+		}
+
 		public override void Emit (EmitContext ec)
 		{
-			ILGenerator ig = ec.ig;
-
-			if (local_info.FieldBuilder == null){
-				//
-				// A local variable on the local CLR stack
-				//
-				ig.Emit (OpCodes.Ldloc, local_info.LocalBuilder);
-			} else {
-				//
-				// A local variable captured by anonymous methods.
-				//
-				if (!prepared)
-					ec.EmitCapturedVariableInstance (local_info);
-				
-				ig.Emit (OpCodes.Ldfld, local_info.FieldBuilder);
-			}
+			Report.Debug (64, "EMIT LOCAL VARIABLE REFERENCE", this, ec, Variable, loc);
+			if (!prepared)
+				Variable.EmitInstance (ec);
+			Variable.Emit (ec);
 		}
 		
 		public void Emit (EmitContext ec, bool leave_copy)
 		{
 			Emit (ec);
-			if (leave_copy){
+			if (leave_copy) {
 				ec.ig.Emit (OpCodes.Dup);
-				if (local_info.FieldBuilder != null){
+				if (Variable.NeedsTemporary) {
 					temp = new LocalTemporary (Type);
 					temp.Store (ec);
 				}
 			}
 		}
-		
-		public void EmitAssign (EmitContext ec, Expression source, bool leave_copy, bool prepare_for_load)
+
+		public void EmitAssign (EmitContext ec, Expression source, bool leave_copy,
+					bool prepare_for_load)
 		{
 			ILGenerator ig = ec.ig;
 			prepared = prepare_for_load;
 
-			if (local_info.FieldBuilder == null){
-				//
-				// A local variable on the local CLR stack
-				//
-				if (local_info.LocalBuilder == null)
-					throw new Exception ("This should not happen: both Field and Local are null");
-
-				source.Emit (ec);
-				if (leave_copy)
-					ec.ig.Emit (OpCodes.Dup);
-				ig.Emit (OpCodes.Stloc, local_info.LocalBuilder);
-			} else {
-				//
-				// A local variable captured by anonymous methods or itereators.
-				//
-				ec.EmitCapturedVariableInstance (local_info);
-
-				if (prepare_for_load)
-					ig.Emit (OpCodes.Dup);
-				source.Emit (ec);
-				if (leave_copy){
-					ig.Emit (OpCodes.Dup);
+			Variable.EmitInstance (ec);
+			if (prepare_for_load && Variable.HasInstance)
+				ig.Emit (OpCodes.Dup);
+			source.Emit (ec);
+			if (leave_copy) {
+				ig.Emit (OpCodes.Dup);
+				if (Variable.NeedsTemporary) {
 					temp = new LocalTemporary (Type);
 					temp.Store (ec);
 				}
-				ig.Emit (OpCodes.Stfld, local_info.FieldBuilder);
-				if (temp != null)
-					temp.Emit (ec);
 			}
+			Variable.EmitAssign (ec);
+			if (temp != null)
+				temp.Emit (ec);
 		}
 		
 		public void AddressOf (EmitContext ec, AddressOp mode)
 		{
-			ILGenerator ig = ec.ig;
-
-			if (local_info.FieldBuilder == null){
-				//
-				// A local variable on the local CLR stack
-				//
-				ig.Emit (OpCodes.Ldloca, local_info.LocalBuilder);
-			} else {
-				//
-				// A local variable captured by anonymous methods or iterators
-				//
-				ec.EmitCapturedVariableInstance (local_info);
-				ig.Emit (OpCodes.Ldflda, local_info.FieldBuilder);
-			}
+			Variable.EmitInstance (ec);
+			Variable.EmitAddressOf (ec);
 		}
 
 		public override string ToString ()
@@ -3562,6 +3527,7 @@
 		}
 
 		LocalTemporary temp;
+		Variable variable;
 		
 		public ParameterReference (Parameter par, Block block, int idx, Location loc)
 		{
@@ -3577,6 +3543,10 @@
 			get { return vi; }
 		}
 
+		public Variable Variable {
+			get { return variable != null ? variable : par.Variable; }
+		}
+
 		public bool VerifyFixed ()
 		{
 			// A parameter is fixed if it's a value parameter (i.e., no modifier like out, ref, param).
@@ -3636,15 +3606,6 @@
 						par.Name);
 					return false;
 				}
-
-				//
-				// If we are referencing the parameter from the external block
-				// flag it for capturing
-				//
-				//Console.WriteLine ("Is parameter `{0}' local? {1}", name, block.IsLocalParameter (name));
-				if (!block.Toplevel.IsLocalParameter (name)){
-					ec.CaptureParameter (name, type, idx);
-				}
 			}
 
 			return true;
@@ -3681,9 +3642,15 @@
 			if (!DoResolveBase (ec))
 				return null;
 
-			if (is_out && ec.DoFlowAnalysis && (!ec.OmitStructFlowAnalysis || !vi.TypeInfo.IsStruct) && !IsAssigned (ec, loc))
+			if (is_out && ec.DoFlowAnalysis &&
+			    (!ec.OmitStructFlowAnalysis || !vi.TypeInfo.IsStruct) && !IsAssigned (ec, loc))
 				return null;
 
+			if (ec.MustCaptureParameter (block, name)) {
+				variable = ec.CaptureParameter (par, idx);
+				type = variable.Type;
+			}
+
 			return this;
 		}
 
@@ -3694,6 +3661,11 @@
 
 			SetAssigned (ec);
 
+			if (ec.MustCaptureParameter (block, name)) {
+				variable = ec.CaptureParameter (par, idx);
+				type = variable.Type;
+			}
+
 			return this;
 		}
 
@@ -3731,7 +3703,68 @@
 			// FIXME: Review for anonymous methods
 			//
 		}
+
+		public override void Emit (EmitContext ec)
+		{
+			Emit (ec, false);
+		}
 		
+		public void Emit (EmitContext ec, bool leave_copy)
+		{
+			if (!prepared)
+				Variable.EmitInstance (ec);
+			Variable.Emit (ec);
+
+			if (is_ref) {
+				if (prepared)
+					ec.ig.Emit (OpCodes.Dup);
+	
+				//
+				// If we are a reference, we loaded on the stack a pointer
+				// Now lets load the real value
+				//
+				LoadFromPtr (ec.ig, type);
+			}
+
+			if (leave_copy) {
+				ec.ig.Emit (OpCodes.Dup);
+
+				if (is_ref || Variable.NeedsTemporary) {
+					temp = new LocalTemporary (Type);
+					temp.Store (ec);
+				}
+			}
+		}
+
+		public void EmitAssign (EmitContext ec, Expression source, bool leave_copy,
+					bool prepare_for_load)
+		{
+			ILGenerator ig = ec.ig;
+			prepared = prepare_for_load;
+
+			Variable.EmitInstance (ec);
+			if (prepare_for_load)
+				ig.Emit (OpCodes.Dup);
+			source.Emit (ec);
+			if (leave_copy) {
+				ig.Emit (OpCodes.Dup);
+				if (Variable.NeedsTemporary) {
+					temp = new LocalTemporary (Type);
+					temp.Store (ec);
+				}
+			}
+			Variable.EmitAssign (ec);
+			if (temp != null)
+				temp.Emit (ec);
+		}
+		
+		public void AddressOf (EmitContext ec, AddressOp mode)
+		{
+			Variable.EmitInstance (ec);
+			Variable.EmitAddressOf (ec);
+		}
+
+#if FIXME
 		public override void Emit (EmitContext ec)
 		{
 			Emit (ec, false);
@@ -3742,8 +3775,11 @@
 			ILGenerator ig = ec.ig;
 			int arg_idx = idx;
 
-			if (ec.HaveCaptureInfo && ec.IsParameterCaptured (name)){				
-				ec.EmitParameter (name, leave_copy, prepared, ref temp);
+			Report.Debug (64, "EMIT PARAMETER REF", this, name, ec.capture_context,
+				      ec.CurrentBlock, ec.CurrentBlock.Toplevel, loc);
+
+			if (ec.HaveCaptureInfo && ec.IsParameterCaptured (name)) {
+				ec.capture_context.EmitParameter (ec, name, leave_copy, prepared, ref temp);
 				return;
 			}
 
@@ -3772,20 +3808,19 @@
 				}
 			}
 		}
-		
+
 		public void EmitAssign (EmitContext ec, Expression source, bool leave_copy, bool prepare_for_load)
 		{
 			prepared = prepare_for_load;
 			if (ec.HaveCaptureInfo && ec.IsParameterCaptured (name)){
-				ec.EmitAssignParameter (name, source, leave_copy, prepare_for_load, ref temp);
+				ec.capture_context.EmitAssignParameter (
+					ec, name, source, leave_copy, prepare_for_load, ref temp);
 				return;
 			}
 
 			ILGenerator ig = ec.ig;
 			int arg_idx = idx;
-			
-			
-			
+
 			if (!ec.MethodIsStatic)
 				arg_idx++;
 
@@ -3818,7 +3853,7 @@
 		public void AddressOf (EmitContext ec, AddressOp mode)
 		{
 			if (ec.HaveCaptureInfo && ec.IsParameterCaptured (name)){
-				ec.EmitAddressOfParameter (name);
+				ec.capture_context.EmitAddressOfParameter (ec, name);
 				return;
 			}
 			
@@ -3839,6 +3874,7 @@
 					ec.ig.Emit (OpCodes.Ldarga, arg_idx);
 			}
 		}
+#endif
 
 		public override string ToString ()
 		{
